use strict;
use warnings;

use Test::More tests => 4;
BEGIN { use_ok('Sloop::Client::Request') };

is_deeply (
	Sloop::Client::Request::qargsFromString (
		'reserved=%21%23%24%26%27%28%29%2A%2B%2C%2F%3A%3B%3D%3F%40%5B%5D'
		.'&foo=bar&okay&foo=666&what',
        1
	), {
		reserved => [ "!#\$&'()*+,/:;=?@[]" ],
		foo => [ 'bar', '666' ],
		okay => [],
		what => []
	},
	'qargsFromString() #1'
);

is_deeply (
	Sloop::Client::Request::qargsFromString('&&=&&', 1),
	{},
	'qargsFromString() #2'
);

is_deeply (
	Sloop::Client::Request::qargsFromString('bob=your+uncle&ralph=foo%8T_&bar=0', 1),
	{
		bob => [ 'your uncle' ],
		ralph => [ "foo\b_" ],
		bar => [ '0' ]
	},
	'qargsFromString() #3'
);
