use strict;
use warnings;

use Test::More tests => 6;
BEGIN { use_ok('Sloop::Client::Request') };

my $http = <<END;
GET /foo/bar/index.html HTTP/1.1\r
Host: localhost:80\r
Accept: Food or money\r
\r
END

my $req = Sloop::Client::Request->new(\$http);
isa_ok($req, 'Sloop::Client::Request', 'ISA');

is($req->{method}, 'get', 'Method');

is($req->{protocol}, 'HTTP/1.1', 'Protocol');

is_deeply (
	$req->{path},
	[ 'foo', 'bar', 'index.html' ],
	'Path'
);

is_deeply (
	$req->{headers},
	{
		host => 'localhost:80',
		accept => 'Food or money'
	}
);
