use strict;
use warnings;

use Test::More tests => 7;
BEGIN { use_ok('Sloop::Client::Request') };

my $req = Sloop::Client::Request->new(\"?WHAT");
isa_ok($req, 'Sloop::Client::Request', 'ISA 1');
is($req->{bad}, 'No recognizable method.', 'Method');


$req = Sloop::Client::Request->new(\"GET foo/bar/index.html HTTP/1.1\r\n\r\n");
isa_ok($req, 'Sloop::Client::Request', 'ISA 2');
is($req->{bad}, 'Invalid path', 'Path #1');

$req = Sloop::Client::Request->new(\"GET /../../foo/bar/.. HTTP/1.1\r\n\r\n");
isa_ok($req, 'Sloop::Client::Request', 'ISA 3');
is_deeply (
	$req->{path},
	[ 'foo', 'bar' ],
	'Path #2'
);


