use strict;
use warnings;

use Test::More tests => 4;
BEGIN { use_ok('Sloop::Client::Request') };

# Malformed headers leave 'headers' undefined.
my $txt = <<END;
GET / HTTP/1.1\r
Incomplete\r
But: what\r
\r
END
my $req = Sloop::Client::Request->new(\$txt);
isa_ok($req, 'Sloop::Client::Request', 'ISA 1');
is (
	$req->{bad},
	'Malformed or incomplete headers.',
	'Incomplete',
);
is($req->{headers}, undef, 'Undef 1');
