use strict;
use warnings;

use Test::More tests => 5;
BEGIN { use_ok('Sloop::Client::Request') };

my $txt = <<END;
GET / HTTP/1.1\r
Cookie: foo=bar; four=two+2\r
Yada:\r
Cookie: three=03 ; five=""\r
\r
END

my $req = Sloop::Client::Request->new(\$txt);
isa_ok($req, 'Sloop::Client::Request', 'ISA 1');
is($req->findCookieValue('foo'), 'bar', 'Simple #1');
is($req->findCookieValue('three'), '03', 'Simple #2');
is($req->findCookieValue('five'), undef, 'Empty');
