use strict;
use warnings;

use Test::More tests => 11;
BEGIN { use_ok('Sloop::Lib', qw(:all)) };

# dataLength()
is(dataLength(\"12345"), 5, 'dataLength() #1');
my $n = 12345;
is(dataLength(\$n), 5, 'dataLength() #2');

# fieldPairs()
my $pairs = fieldPairs('one;two=7;THREE;', 1);
is_deeply($pairs, {
	one => '',
	two =>  '7',
	three => ''
}, 'fieldPairs()');

# splitstr()
my $s = 'foobar';
my $s2 = splitstr($s, 3);
is($s, 'bar', 'splitstr() #1');
is($s2, 'foo', 'splitstr() #2');

# tailstr()
$s = 'whatnext';
Sloop::Lib::tailstr($s, 4);
is($s, 'next', 'tailstr');

#terminateDirPath()
$s = '/foo/bar';
Sloop::Lib::terminateDirPath($s);
is($s, '/foo/bar/', 'terminateDirPath');

# toInteger()
$n = '123';
is(Sloop::Lib::toInteger($n), 1, 'toInteger() #1');
is($n, 123, 'toInteger() #2');
is(Sloop::Lib::toInteger('adsf'), 0, 'toInteger #3');
