use strict;
use warnings;

use Sloop::Client::Request;

use Test::More tests => 5;
BEGIN { use_ok('Sloop::Multipart') };

my $upload = <<END;
POST / HTTP/1.1\r
Content-type: multipart/form-data; boundary=foobar\r
Content-length: 224\r
\r
--foobar\r
Content-disposition: form-data; name="foo"\r
\r
bar\r
--foobar\r
Content-disposition: form-data; name="bar"\r
\r
foo\r
--foobar--\r
END

my $req = Sloop::Client::Request->new(\$upload);
my $multi = Sloop::Multipart->new($req, 256, 't', 'foo');

is($multi->process(\$req->{body}), 1);
is($multi->{parts}->[0]->size, 3);
is($multi->{expected}->{foo}->getContent, 'bar');
is($multi->{parts}->[0]->getContent, 'foo');
#print STDERR "\n$multi->{error}\n";
