#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#define NEED_sv_2pv_flags
#include "ppport.h"

#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <time.h>
#include <unistd.h>


MODULE = Sloop::Socket::Standard		PACKAGE = Sloop::Socket::Standard

PROTOTYPES: ENABLE


int peekInSocket (objref)
SV *objref
CODE:
	HV *self = (HV*)SvRV(objref);
	SV **field = hv_fetch(self, "fd", 2, 0);
	char buf[4];
	RETVAL = recv(SvIV(*field), buf, 4, MSG_PEEK);
OUTPUT:
	RETVAL


void shut (objref)
SV *objref
CODE:
	HV *self = (HV*)SvRV(objref);
	SV **field = hv_fetch(self, "SHUT", 4, 0);
	int shut = SvIV(*field);

	// already closed?
	if (shut) return;
	sv_setiv(*field, 1);

	// close
	field = hv_fetch(self, "fd", 2, 0);
	int sock = SvIV(*field);
	shutdown(sock, 2);
	close(sock);


SV *sysread (objref, buf, len)
SV *objref
SV *buf
int len
CODE:
// Duplicates the functionality of perl's OO sysread.
	HV *self = (HV*)SvRV(objref);
	SV **field = hv_fetch(self, "fd", 2, 0);
	SvGROW(buf, len+1);
	unsigned char *data = (unsigned char*)SvPV_nolen(buf);

	int bytes = read(SvIV(*field), data, len);
	if (bytes < 0) {
		if (errno != EAGAIN) {
		// See comment in Server.xs Epoll() regarding strerror vs. strerror_r.
			char *s = strerror(errno);
			hv_store(self, "readErrStr", 10, newSVpv(s, strlen(s)), 0);
		}
		hv_store(self, "readerr", 7, newSViv(errno), 0);
		XSRETURN_UNDEF;
	}

	// This terminator is mostly superflous and intentionally excluded
	// from the length set on the SV and returned to the caller.  It
	// is just there in case someone uses a C string function on the data.
	data[bytes] = '\0';
	SvCUR_set(buf, bytes);
	RETVAL = newSViv(bytes);
OUTPUT:
	RETVAL


SV *syswrite (objref, data, len)
SV *objref
char *data
int len
CODE:
// Duplicates the functionality of perl's OO syswrite.
	HV *self = (HV*)SvRV(objref);
	SV **field = hv_fetch(self, "fd", 2, 0);

	int bytes = write(SvIV(*field), data, len);
	if (bytes == -1) RETVAL = &PL_sv_undef; // undef on error
	else RETVAL = newSViv(bytes);
OUTPUT:
	RETVAL
