use strict;
use warnings;

use Test::More;
use Sloop::Client::Regular;
use Sloop::Logger;

my ($in, $out);
pipe($in, $out);
my $s = "Hello world.\n";

my $pid = fork();
die "fork() fail: $!" if !defined $pid;

if (!$pid) { print $out $s }
else {

	plan tests => 3;

	my $client = Sloop::Client::Regular->new (
		fd => fileno($in),
		id => 'Test',
		logger => Sloop::Logger->new()
	);
	isa_ok($client, 'Sloop::Client');

	my $data = "";
	my $len = $client->sysread($data, 32);
	ok($data eq $s);
	ok($len == length($s));

}
