use strict;
use warnings;

use Test::More;
use Sloop::Client::Regular;
use Sloop::Logger;

my ($in, $out);
pipe($in, $out);
my $s = "Hello world.\n";

my $client = Sloop::Client::Regular->new (
	fd => fileno($out),
	id => 'Test',
	logger => Sloop::Logger->new()
);

my $pid = fork();
die "fork() fail: $!" if !defined $pid;

if (!$pid) {
	$client->syswrite($s, length($s));
}
else {

	plan tests => 2;
	isa_ok($client, 'Sloop::Client');

	my $data = <$in>;
	ok($data eq $s);

}
