#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#define NEED_newRV_noinc
#include "ppport.h"

#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <malloc.h>


MODULE = Sloop::Static		PACKAGE = Sloop::Static

PROTOTYPES: ENABLE


SV *firstSlurp (path, szref, client)
char *path
SV *szref
HV *client
CODE:
	struct stat info;
	if (stat(path, &info)) XSRETURN_UNDEF;

	int fd = open(path, O_RDONLY);
	if (fd == -1) XSRETURN_UNDEF;

	/* get file */
	SV **field = hv_fetch(client, "max_send", 8, 0);
	size_t max = SvIV(*field);

	size_t len;
	int closeAfter = 1;
	if (info.st_size > max) {
		len = max;
		closeAfter = 0;
	} else len = info.st_size;

	char *buf = malloc(len);
	if (!buf) {
		close(fd);
		XSRETURN_UNDEF;
	}

	int actual = read(fd, buf, len);
	if (actual == -1) {
		free(buf);
		close(fd);
		hv_delete(client, "!S:S!_file_fd", 13, G_DISCARD);
		XSRETURN_UNDEF;
	}

	if (closeAfter) {
		close(fd);
		hv_delete(client, "!S:S!_file_fd", 13, G_DISCARD);
	} else hv_store(client, "!S:S!_file_fd", 13, newSViv(fd), 0);

	// pass back total file size
	SV *size = SvRV(szref);
	sv_setiv(size, info.st_size);

	// return data read
	SV *data = newSVpv(buf, actual);
	free(buf);
	RETVAL = newRV_noinc(data);
OUTPUT:
	RETVAL


SV *continueSlurp (client)
HV *client
CODE:
	// allocate buffer
	SV **field = hv_fetch(client, "max_send", 8, 0);
	int max = SvIV(*field);
	char *buf = malloc(max);
	if (!buf) XSRETURN_UNDEF;

	// read file
	field = hv_fetch(client, "!S:S!_file_fd", 13, 0);
	int fd = SvIV(*field);

	int actual = read(fd, buf, max);

	if (actual <= 0) {
		hv_delete(client, "!S:S!_file_fd", 13, G_DISCARD);
		hv_store(client, "buffer_data", 11, newSV(0), 0);
		free(buf);
		return XSRETURN_UNDEF;
	}

	// return data
	SV *data = newSVpv(buf, actual);
	free(buf);
	RETVAL = newRV_noinc(data);
OUTPUT:
	RETVAL
