use strict;
use warnings;

use Cwd;
use Test::More tests => 2;
BEGIN { use_ok('Sloop::Static') };

use Sloop::Client::Regular;
use Sloop::Logger;

my $garbage = "";
open my $discard, '>', \$garbage;

my $client = Sloop::Client::Regular->new (
	fd => -1,
	epfd => -1,
	id => 'Test',
	logger => Sloop::Logger->new( logs => [$discard, \*STDOUT, \*STDOUT]),
	request => Sloop::Client::Request->new(\"GET /Static.t HTTP/1.1\r\n\r\n"),
	max_send => 32,
	maxage => 0,
);

$client->{request}->{path} = [ 't', 'test.data' ];
$client->{request}->{level} = 1;

Sloop::Static::directory ( $client,
	path => getcwd().'/t'
);

my $reply = <<END;
HTTP/1.1 200 OK\r
Server: Perl Sloop\r
Cache-Control: max-age=0\r
Expires: Sat, 1 Jan 2000 4:20:20 GMT\r
Content-Length: 82\r
Content-Type: text/plain\r
Connection: close\r
\r
Test abcdefghijklmnopqrstuvwxyz!
END
chomp $reply;


is_deeply (
	$client->{data_pending},
	\$reply,
	'directory()'
);
